//		----------------------------------------------------------
//		-- fredrik olofsson 010505 (rev.011004)					--
//		-- updated for carbon using cw8.0 040225				--
//		-- divide by 0 bugfix 060507 (051228)					--
//		-- updated for ub using xcode 070103					--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

//#include <math.h>		//target specific - uncomment for classic

#include "ext.h"

void *this_class;

typedef struct _f0ext {
	t_object x_ob;
	long x_valLeft;
	long x_valRight;
	long x_valOut;
	void *x_out;
} x_f0ext;

void *f0ext_new(Symbol *s, short ac, Atom *av);
void f0ext_int(x_f0ext *f0ext, long value);
void f0ext_float(x_f0ext *f0ext, double value);
void f0ext_ft1(x_f0ext *f0ext, double value);
void f0ext_list(x_f0ext *f0ext, Symbol *s, short ac, Atom *av);
void f0ext_bang(x_f0ext *f0ext);
long greatestCommonDivisor(long a, long b);
void f0ext_assist(x_f0ext *f0ext, void *box, long msg, long arg, char *dst);

//----------------------------------------------------------------------------------------------
void main(void) {
	setup((Messlist **)&this_class, (method)f0ext_new, 0L, (short)sizeof(x_f0ext), 0L, 0);
	addbang((method)f0ext_bang);
	addint((method)f0ext_int);
	addfloat((method)f0ext_float);
	addftx((method)f0ext_ft1, 1);
	addmess((method)f0ext_list, "list", A_GIMME, 0);
	addmess((method)f0ext_assist, "assist", A_CANT, 0);
	finder_addclass("All Objects", "f0.gcd");
	finder_addclass("Math", "f0.gcd");
	post("f0.gcd v1.1.4-win; distributed under GNU GPL license");		//target specific
}
void *f0ext_new(Symbol *s, short ac, Atom *av) {
	x_f0ext *f0ext;
	f0ext= (x_f0ext *)newobject(this_class);
	f0ext->x_valLeft= 0;
	f0ext->x_valRight= 0;
	floatin(f0ext, 1);
	f0ext->x_out= intout(f0ext);
	return(f0ext);
}
void f0ext_assist(x_f0ext *f0ext, void *box, long msg, long arg, char *dst) {
	if(msg==ASSIST_INLET) {
		switch(arg) {
			case 0:
				sprintf(dst, "number (int)");
				break;
			case 1:
				sprintf(dst, "number (int)");
				break;
		}
	} else if(msg==ASSIST_OUTLET) {
		sprintf(dst, "greatest common divisor (int)");
	}
}

//----------------------------------------------------------------------------------------------
void f0ext_int(x_f0ext *f0ext, long value) {
	f0ext->x_valLeft= value;
	f0ext->x_valOut= greatestCommonDivisor(f0ext->x_valLeft, f0ext->x_valRight);
	f0ext_bang(f0ext);
}
void f0ext_float(x_f0ext *f0ext, double value) {
	f0ext->x_valLeft= (long)value;
	f0ext->x_valOut= greatestCommonDivisor(value, f0ext->x_valRight);
	f0ext_bang(f0ext);
}
void f0ext_ft1(x_f0ext *f0ext, double value) {
	f0ext->x_valRight= (long)value;
	f0ext->x_valOut= greatestCommonDivisor(f0ext->x_valLeft, f0ext->x_valRight);
}
void f0ext_list(x_f0ext *f0ext, Symbol *s, short ac, Atom *av) {
	register short i;
	long a= 0, b= 0;
	if(av->a_type==A_LONG) {
		a= av->a_w.w_long;
	} else if(av->a_type==A_FLOAT) {
		a= (long)av->a_w.w_float;
	}
	av++;
	for(i= 1; i<ac; i++, av++) {
		if(av->a_type==A_LONG) {
			b= av->a_w.w_long;
		} else if (av->a_type==A_FLOAT) {
			b= (long)av->a_w.w_float;
		}
		a= greatestCommonDivisor(a, b);
	}
	f0ext->x_valOut= a;
	f0ext_bang(f0ext);
}
void f0ext_bang(x_f0ext *f0ext) {
	outlet_int(f0ext->x_out, f0ext->x_valOut);
}

//----------------------------------------------------------------------------------------------
long greatestCommonDivisor(long a, long b) {	
	if(b==0) {
		return 0;
	}
	if(a%b!=0) {
		return greatestCommonDivisor(b, a % b);
	} else {
		return fabs(b);
	}
}
