//		----------------------------------------------------------
//		-- fredrik olofsson 010614 (rev.011004)					--
//		-- updated for carbon using cw8.0 040225				--
//		-- minor updates 060507									--
//		-- updated for ub using xcode 070103					--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

//#include <math.h>		//target specific - uncomment for classic

#include "ext.h"

void *this_class;

typedef struct _f0ext {
	t_object x_ob;
	long x_valOut;
	void *x_out;
} x_f0ext;

void *f0ext_new(void);
void f0ext_bang(x_f0ext *x);
void f0ext_int(x_f0ext *x, long index);
long f0ext(long index);
long count_bits(long n);
void f0ext_assist(x_f0ext *x, void *box, long msg, long arg, char *dst);

//----------------------------------------------------------------------------------------------
void main(void) {
	setup((Messlist **)&this_class, (method)f0ext_new, 0L, (short)sizeof(x_f0ext), 0L, 0);
	addbang((method)f0ext_bang);
	addint((method)f0ext_int);
	addmess((method)f0ext_assist, "assist", A_CANT, 0);
	finder_addclass("All Objects", "f0.noergaard");
	finder_addclass("Math", "f0.noergaard");
	post("f0.noergaard v1.0.4-win; distributed under GNU GPL license");		//target specific
}
void *f0ext_new(void) {
	x_f0ext *x;
	x= (x_f0ext *)newobject(this_class);
	x->x_valOut= 0;
	x->x_out= intout(x);
	return(x);
}
void f0ext_assist(x_f0ext *x, void *box, long msg, long arg, char *dst) {
	if(msg==ASSIST_INLET) {
		sprintf(dst, "index >=0 (int)");
	} else if(msg==ASSIST_OUTLET) {
		sprintf(dst, "value (int)");
	}
}

//----------------------------------------------------------------------------------------------
void f0ext_int(x_f0ext *x, long index) {
	if(index>=0) {
		x->x_valOut= f0ext(index);
		f0ext_bang(x);
	}
}
void f0ext_bang(x_f0ext *x) {
	outlet_int(x->x_out, x->x_valOut);
}

//----------------------------------------------------------------------------------------------
long f0ext(long index) {
	long i, len, res= 0;
	len= count_bits(index);
	for(i= len-1; i>=0; i--) {
		if((index>>i)&01) {
			res++;
		} else {
			if(res>=0) {
				res= 0-res;
			} else {
				res= fabs(res);
			}
		}
	}
	return res;
}
long count_bits(long n) {
	long i= 0;
	for(; n!=0; n= n>>1) {
		i++;
	}
	return i;
}
