//		----------------------------------------------------------
//		-- fredrik olofsson 040329 (rev.060511)					--
//		-- updated for ub using xcode 070103					--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "ext.h"

#define LONG_MIN -2147483647		//target specific - uncomment for windows
#define LONG_MAX 2147483647

void *this_class;

typedef struct _f0_range {
	t_object x_ob;
	double x_valLeft;
	double x_min;
	double x_max;
	double x_setMin;
	double x_setMax;
	short x_setFlag;
	void *x_out;
	void *x_out2;
	void *x_out3;
} x_f0_range;

void *f0_range_new(double value1, double value2);
void f0_range_int(x_f0_range *f0_range, long value);
void f0_range_float(x_f0_range *f0_range, double value);
void f0_range_bang(x_f0_range *f0_range);
void f0_range_set(x_f0_range *f0_range, double value1, double value2);
void f0_range_func(x_f0_range *f0_range);
void f0_range_assist(x_f0_range *f0_range, void *box, long msg, long arg, char *dst);

//----------------------------------------------------------------------------------------------
void *f0_range_new(double value1, double value2) {
	x_f0_range *f0_range= (x_f0_range *)newobject(this_class);
	if(value1==0&&value2==0) {
		f0_range->x_setMin= LONG_MAX;
		f0_range->x_setMax= LONG_MIN;
		f0_range->x_setFlag= 0;
	} else {
		f0_range->x_setMin= value1;
		f0_range->x_setMax= value2;
		f0_range->x_setFlag= 2;
	}
	f0_range->x_min= f0_range->x_setMin;
	f0_range->x_max= f0_range->x_setMax;
	f0_range->x_out3= floatout(f0_range);
	f0_range->x_out2= floatout(f0_range);
	f0_range->x_out= floatout(f0_range);
	return(f0_range);
}
void f0_range_assist(x_f0_range *f0_range, void *box, long msg, long arg, char *dst) {
	if(msg==ASSIST_INLET) {
		sprintf(dst, "values to check (int/float)");
	} else if(msg==ASSIST_OUTLET) {
		switch(arg) {
			case 0:
				sprintf(dst, "minimum value (float)");
				break;
			case 1:
				sprintf(dst, "middle value (float)");
				break;
			case 2:
				sprintf(dst, "maximum value (float)");
		}
	}
}

//----------------------------------------------------------------------------------------------
void f0_range_int(x_f0_range *f0_range, long value) {
	f0_range->x_valLeft= value;
	f0_range_func(f0_range);
}
void f0_range_float(x_f0_range *f0_range, double value) {
	f0_range->x_valLeft= value;
	f0_range_func(f0_range);
}
void f0_range_bang(x_f0_range *f0_range) {
	if(f0_range->x_setFlag==0) {
		f0_range->x_min= LONG_MAX;
		f0_range->x_max= LONG_MIN;
	} else {
		f0_range->x_min= f0_range->x_setMin;
		f0_range->x_max= f0_range->x_setMax;
	}
}
void f0_range_set(x_f0_range *f0_range, double value1, double value2) {
	if(value1<value2) {
		f0_range->x_min= value1;
		f0_range->x_max= value2;
		f0_range->x_setMin= value1;
		f0_range->x_setMax= value2;
	} else {
		f0_range->x_min= value2;
		f0_range->x_max= value1;
		f0_range->x_setMin= value2;
		f0_range->x_setMax= value1;
	}
	f0_range->x_setFlag= 2;
}

//----------------------------------------------------------------------------------------------
void f0_range_func(x_f0_range *f0_range) {
	if(f0_range->x_valLeft>f0_range->x_max) {
		f0_range->x_max= f0_range->x_valLeft;
	}
	if(f0_range->x_valLeft<f0_range->x_min) {
		f0_range->x_min= f0_range->x_valLeft;
	}
	outlet_float(f0_range->x_out3, f0_range->x_max);
	outlet_float(f0_range->x_out2, (f0_range->x_max-f0_range->x_min)/2+f0_range->x_min);
	outlet_float(f0_range->x_out, f0_range->x_min);
}

//----------------------------------------------------------------------------------------------
void main(void) {
	setup((Messlist **)&this_class, (method)f0_range_new, 0L, (short)sizeof(x_f0_range), 0L, A_DEFFLOAT, A_DEFFLOAT, 0);
	addbang((method)f0_range_bang);
	addint((method)f0_range_int);
	addfloat((method)f0_range_float);
	addmess((method)f0_range_set, "set", A_FLOAT, A_FLOAT, 0);
	addmess((method)f0_range_assist, "assist", A_CANT, 0);
	finder_addclass("All Objects", "f0.range");
	finder_addclass("Math", "f0.range");
	post("f0.range v1.0.2-win; distributed under GNU GPL license");		//target specific
}
