//		----------------------------------------------------------
//		-- fredrik olofsson 040301								--
//		-- converted from abstraction with the same name		--
//		-- updated for ub using xcode 070103					--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "ext.h"

void *this_class;

typedef struct _f0ext {
	t_object x_ob;
	double x_valLeft;
	double x_valRight;
	double x_proportionLeft;
	double x_proportionRight;
	void *x_out;
	void *x_out2;
} x_f0ext;

void *f0ext_new(double value1, double value2);
void f0ext_int(x_f0ext *f0ext, long value);
void f0ext_float(x_f0ext *f0ext, double value);
void f0ext_ft1(x_f0ext *f0ext, double value);
void f0ext_bang(x_f0ext *f0ext);
void f0ext_set(x_f0ext *f0ext, double value1, double value2);
void f0ext_assist(x_f0ext *f0ext, void *box, long msg, long arg, char *dst);

//----------------------------------------------------------------------------------------------
void main(void) {
	setup((Messlist **)&this_class, (method)f0ext_new, 0L, (short)sizeof(x_f0ext), 0L, A_DEFFLOAT, A_DEFFLOAT, 0);
	addbang((method)f0ext_bang);
	addint((method)f0ext_int);
	addfloat((method)f0ext_float);
	addftx((method)f0ext_ft1, 1);
	addmess((method)f0ext_set, "set", A_FLOAT, A_FLOAT, 0);
	addmess((method)f0ext_assist, "assist", A_CANT, 0);
	finder_addclass("All Objects", "f0.ratio");
	finder_addclass("Control", "f0.ratio");
	post("f0.ratio v1.0.1-win; distributed under GNU GPL license");		//target specific
}
void *f0ext_new(double value1, double value2) {
	x_f0ext *f0ext;
	f0ext= (x_f0ext *)newobject(this_class);
	f0ext->x_valLeft= 0;
	if(value1==0&&value2==0) {
		f0ext->x_proportionLeft= 1;
		f0ext->x_proportionRight= 1;
	} else if(value1!=0&&value2==0) {
		f0ext->x_proportionLeft= value1;
		f0ext->x_proportionRight= 1;
	} else {
		f0ext->x_proportionLeft= value1;
		f0ext->x_proportionRight= value2;
	}
	f0ext->x_out2= floatout(f0ext);
	f0ext->x_out= floatout(f0ext);
	floatin(f0ext, 1);
	return(f0ext);
}
void f0ext_assist(x_f0ext *f0ext, void *box, long msg, long arg, char *dst) {
	if(msg==ASSIST_INLET) {
		switch(arg) {
			case 0:
				sprintf(dst, "width (int/float)");
				break;
			case 1:
				sprintf(dst, "height (float)");
		}
	} else if(msg==ASSIST_OUTLET) {
		switch(arg) {
			case 0:
				sprintf(dst, "width out (float)");
				break;
			case 1:
				sprintf(dst, "height out (float)");
		}
	}
}

//----------------------------------------------------------------------------------------------
void f0ext_int(x_f0ext *f0ext, long value) {
	f0ext->x_valLeft= value;
	f0ext->x_valRight= (value/f0ext->x_proportionLeft)*f0ext->x_proportionRight;
	f0ext_bang(f0ext);
}
void f0ext_float(x_f0ext *f0ext, double value) {
	f0ext->x_valLeft= value;
	f0ext->x_valRight= (value/f0ext->x_proportionLeft)*f0ext->x_proportionRight;
	f0ext_bang(f0ext);
}
void f0ext_ft1(x_f0ext *f0ext, double value) {
	f0ext->x_valLeft= (value/f0ext->x_proportionRight)*f0ext->x_proportionLeft;
	f0ext->x_valRight= value;
	f0ext_bang(f0ext);
}
void f0ext_bang(x_f0ext *f0ext) {
	outlet_float(f0ext->x_out2, f0ext->x_valRight);
	outlet_float(f0ext->x_out, f0ext->x_valLeft);
}
void f0ext_set(x_f0ext *f0ext, double value1, double value2) {
	if(value1==0) {
		f0ext->x_proportionLeft= 1;
	} else {
		f0ext->x_proportionLeft= value1;
	}
	if(value2==0) {
		f0ext->x_proportionRight= 1;
	} else {
		f0ext->x_proportionRight= value2;
	}
}
