//		----------------------------------------------------------
//		-- fredrik olofsson 020115								--
//		-- updated for carbon using cw8.0 040225				--
//		-- fix for output on right input 060507					--
//		-- updated for ub using xcode 070103					--
//		-- clip arg fix 070106									--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "ext.h"
#include "ext_common.h"

void *this_class;

typedef struct _f0ext {
	t_object x_ob;
	double x_valLeft;
	double x_valRight;
	double x_valOut;
	double x_temp;
	void *x_out;
} x_f0ext;

void *f0ext_new(double value);
void f0ext_int(x_f0ext *f0ext, long value);
void f0ext_float(x_f0ext *f0ext, double value);
void f0ext_ft1(x_f0ext *f0ext, double value);
void f0ext_set(x_f0ext *f0ext, double value);
void f0ext_bang(x_f0ext *f0ext);
void theFunction(x_f0ext *f0ext);
void f0ext_assist(x_f0ext *f0ext, void *box, long msg, long arg, char *dst);

//----------------------------------------------------------------------------------------------
void main(void) {
	setup((Messlist **)&this_class, (method)f0ext_new, 0L, (short)sizeof(x_f0ext), 0L, A_DEFFLOAT, 0);
	addbang((method)f0ext_bang);
	addint((method)f0ext_int);
	addfloat((method)f0ext_float);
	addftx((method)f0ext_ft1, 1);
	addmess((method)f0ext_set, "set", A_FLOAT, 0);
	addmess((method)f0ext_assist, "assist", A_CANT, 0);
	finder_addclass("All Objects", "f0.smooth");
	finder_addclass("Math", "f0.smooth");
	post("f0.smooth v1.11-win; distributed under GNU GPL license");		//target specific
}
void *f0ext_new(double value) {
	x_f0ext *f0ext;
	f0ext= (x_f0ext *)newobject(this_class);
	f0ext->x_valLeft= 0;
	f0ext->x_valOut= 0;
	f0ext->x_temp= 0;
	if(value>0) {
		f0ext->x_valRight= CLIP(value, 0, 1);
	} else {
		f0ext->x_valRight= 0.15;
	}
	f0ext->x_out= floatout(f0ext);
	floatin(f0ext, 1);
	return(f0ext);
}
void f0ext_assist(x_f0ext *f0ext, void *box, long msg, long arg, char *dst) {
	if(msg==ASSIST_INLET) {
		switch(arg) {
			case 0:
				sprintf(dst, "values to smooth (int/float)");
				break;
			case 1:
				sprintf(dst, "smoothing constant alpha (float)");
				break;
		}
	} else if(msg==ASSIST_OUTLET) {
		sprintf(dst, "smoothed output (float)");
	}
}

//----------------------------------------------------------------------------------------------
void f0ext_int(x_f0ext *f0ext, long value) {
	f0ext->x_valLeft= value;
	theFunction(f0ext);
}
void f0ext_float(x_f0ext *f0ext, double value) {
	f0ext->x_valLeft= value;
	theFunction(f0ext);
}
void f0ext_ft1(x_f0ext *f0ext, double value) {
	f0ext->x_valRight= CLIP(value, 0, 1);
}
void f0ext_set(x_f0ext *f0ext, double value) {
	f0ext->x_valOut= value;
}
void f0ext_bang(x_f0ext *f0ext) {
	theFunction(f0ext);
}

//----------------------------------------------------------------------------------------------
void theFunction(x_f0ext *f0ext) {
	double St0, St1, a, Yt1;
	a= f0ext->x_valRight;
	St1= f0ext->x_valOut;
	Yt1= f0ext->x_temp;
	St0= a*Yt1+(1-a)*St1;	//SES - Single Exponential Smoothing, Hunter (1986)
	f0ext->x_valOut= St0;
	f0ext->x_temp= f0ext->x_valLeft;
	outlet_float(f0ext->x_out, f0ext->x_valOut);
}
