//		----------------------------------------------------------
//		-- fredrik olofsson 020206								--
//		-- updated for carbon using cw8.0 040225				--
//		-- updated for wmax using cygwin 051016					--
//		-- updated for ub using xcode 070103					--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "ext.h"

void *this_class;

typedef struct _snap {
	t_object s_ob;
	double s_valueLeft;
	double s_valueRight;
	double s_valueOut;
	void *s_out;
} s_snap;

void *snap_new(double value);
void snap_int(s_snap *snap, long value);
void snap_float(s_snap *snap, double value);
void snap_ft1(s_snap *snap, double value);
void snap_set(s_snap *snap, double value);
void snap_bang(s_snap *snap);
void theFunction(s_snap *snap);
void snap_assist(s_snap *snap, Object *s, long msg, long arg, char *dst);

//----------------------------------------------------------------------------------------------

void main(void) {
	setup((Messlist **)&this_class, (method)snap_new, 0L, (short)sizeof(s_snap), 0L, A_DEFFLOAT, 0);
	
	addbang((method)snap_bang);
	addint((method)snap_int);
	addfloat((method)snap_float);
	addftx((method)snap_ft1, 1);
	addmess((method)snap_set, "set", A_FLOAT, 0);
	
	addmess((method)snap_assist, "assist", A_CANT, 0);
	
	finder_addclass("All Objects", "f0.snap");
	finder_addclass("Math", "f0.snap");
	
	post("f0.snap v1.0.1-win; distributed under GNU GPL license");		//target specific
}

void *snap_new(double value) {
	s_snap *snap;
	snap = (s_snap *)newobject(this_class);
	snap->s_valueLeft = 0;
	snap->s_valueOut = 0;
	
	if (value>0) {
		snap->s_valueRight = value;
	} else {
		snap->s_valueRight = 50;
	}
	
	snap->s_out = floatout(snap);
	floatin(snap, 1);
	
	return(snap);
}

void snap_assist(s_snap *snap, Object *s, long msg, long arg, char *dst) {
	if(msg==ASSIST_INLET) {
		switch(arg) {
			case 0:
				sprintf(dst, "input values (float)");
				break;
			case 1:
				sprintf(dst, "resistance (float)");
				break;
		}
	} else if(msg==ASSIST_OUTLET) {
		sprintf(dst, "output values (float)");
	}
}

//----------------------------------------------------------------------------------------------

void snap_int(s_snap *snap, long value) {
	snap->s_valueLeft = value;
	theFunction(snap);
}

void snap_float(s_snap *snap, double value) {
	snap->s_valueLeft = value;
	theFunction(snap);
}

void snap_ft1(s_snap *snap, double value) {
	snap->s_valueRight = value;
}

void snap_set(s_snap *snap, double value) {
	snap->s_valueOut = value;
}

void snap_bang(s_snap *snap) {
	theFunction(snap);
}

//----------------------------------------------------------------------------------------------

void theFunction(s_snap *snap) {
	double stepSize,inputVal,counterVal,diff;
	
	stepSize = 0;
	inputVal = snap->s_valueLeft;
	counterVal = snap->s_valueOut;
	diff = fabs(inputVal-counterVal);
	
	if (diff!=0)
		stepSize = snap->s_valueRight/diff;
	
	if (inputVal>counterVal) {
		counterVal = counterVal+stepSize;
		if (counterVal>inputVal)
			counterVal = inputVal;
	} else if (inputVal<counterVal) {
		counterVal = counterVal-stepSize;
		if (counterVal<inputVal)
			counterVal = inputVal;
	}
	
	snap->s_valueOut = counterVal;

	outlet_float(snap->s_out, snap->s_valueOut);
}
